<template>
    <TableHeader ref="TableHeaderRef">
        <template #select>
            <el-form-item label="工程名称">
                <el-input v-model="tableStore.table.params.projectName" clearable></el-input>
            </el-form-item>
            <el-form-item label="所属地市">
                <el-select v-model="tableStore.table.params.city" clearable placeholder="请选择所属地市">
                    <el-option
                        v-for="item in areaOptionList"
                        :key="item.id"
                        :label="item.name"
                        :value="item.name"
                    ></el-option>
                </el-select>
            </el-form-item>
        </template>
        <template #operation>
            <!-- <el-button icon="el-icon-Plus" type="primary" @click="addList">新增</el-button> -->
            <el-button icon="el-icon-Plus" type="primary" @click="addFormModel">新增</el-button>
            <!-- <el-button icon="el-icon-Download" @click="exportEvent" type="primary">导出</el-button> -->
        </template>
    </TableHeader>
    <Table ref="tableRef" />
    <!-- 新增 -->
    <Add ref="addRef" @onSubmit="tableStore.index()" />
    <!-- 上传 -->
    <Audit ref="AuditRef" @onSubmit="tableStore.index()" />
    <!-- 查看详情 detail 新增/修改 create-->
    <addForm ref="addForms" @onSubmit="tableStore.index()" openType="create"></addForm>
</template>
<script setup lang="ts">
import { ref, onMounted, provide, nextTick } from 'vue'
import TableStore from '@/utils/tableStore'
import Table from '@/components/table/index.vue'
import TableHeader from '@/components/table/header/index.vue'
import { useRouter } from 'vue-router'
import Add from './add.vue'
import Audit from './audit.vue'
import addForm from './addForm.vue'
import { useDictData } from '@/stores/dictData'
import { getLoadTypeUserList } from '@/api/process-boot/interference'
const dictData = useDictData()
const { push } = useRouter()

const TableHeaderRef = ref()
const tableRef = ref()
const areaOptionList = dictData.getBasicData('jibei_area')
const addRef = ref()
const AuditRef = ref()
const ruleFormRef = ref()
const show: any = ref(false)
const fileList = ref([])
const tableStore = new TableStore({
    url: '/supervision-boot/userReport/getUserReport',
    publicHeight: 65,
    method: 'POST',
    column: [
        { title: '序号', type: 'seq', width: 80 },
        // { field: 'responsibleDepartment', title: '归口管理部门', minWidth: 130 },
        { field: 'city', title: '所属地市', minWidth: 80 },
        { field: 'substation', title: '变电站', minWidth: 100 },
        { field: 'projectName', title: '工程名称', minWidth: 170 },
        {
            field: 'userType',
            title: '用户性质',
            minWidth: 150,
            formatter: (obj: any) => {
                const userType = obj.row.userType
                return getUserTypeName(userType)
            }
        },
        {
            field: 'userStatus',
            title: '用户状态',
            minWidth: 100,
            render: 'tag',
            custom: {
                0: 'primary',
                1: 'primary',
                2: 'success',
                3: 'warning'
            },
            replaceValue: {
                0: '可研',
                1: '建设',
                2: '运行',
                3: '退运'
            }
        },
        {
            field: 'status',
            title: '审核状态',
            minWidth: 100,
            render: 'tag',
            custom: {
                1: 'primary',
                2: 'success',
                3: 'danger',
                4: 'warning'
            },
            replaceValue: {
                1: '审批中',
                2: '审批通过',
                3: '审批不通过',
                4: '已取消'
            }
        },
        { field: 'createTime', title: '开始时间', minWidth: 170 },
        {
            title: '操作',
            minWidth: 150,
            fixed: 'right',
            render: 'buttons',
            buttons: [
                {
                    name: 'productSetting',
                    title: '流程详情',
                    type: 'primary',
                    icon: 'el-icon-EditPen',
                    render: 'basicButton',
                    click: row => {
                        handleAudit(row.processInstanceId)
                    }
                }
            ]
        }
    ],

    beforeSearchFun: () => {
        tableStore.table.params.orgNo = tableStore.table.params.deptIndex
        tableStore.table.params.relationUserName = tableStore.table.params.userName
    }
})
tableStore.table.params.city='' 
tableStore.table.params.projectName='' 
tableStore.table.params.loadType = ''
tableStore.table.params.userName = ''
tableStore.table.params.fileUploadflag = ''

provide('tableStore', tableStore)
// 新增
const addList = () => {
    addRef.value.open()
}

const addForms = ref()
const addFormModel = () => {
    show.value=true
    setTimeout(() => {
        addForms.value.open()
    }, 0);
  
}

// 导出
const exportEvent = () => {
    let form = JSON.parse(JSON.stringify(tableStore.table.params))
    form.pageNum = 1
    form.pageSize = tableStore.table.total
    getLoadTypeUserList(form).then(res => {
        tableRef.value.getRef().exportData({
            filename: '未建档非线性用户', // 文件名字
            sheetName: 'Sheet1',
            type: 'xlsx', //导出文件类型 xlsx 和 csv
            useStyle: true,
            data: res.data.records, // 数据源 // 过滤那个字段导出
            columnFilterMethod: function (column: any) {
                return !(column.$columnIndex === 0)
            }
        })
    })
}
onMounted(() => {
    tableStore.index()
})

/** 处理审批按钮 */
const handleAudit = (instanceId: any) => {
    push({
        name: 'BpmProcessInstanceDetail',
        query: {
            id: instanceId
        }
    })
}

/**获取用户性质*/
const getUserTypeName = (userType: any) => {
    if (userType === 0) {
        return '新建电网工程'
    }
    if (userType === 1) {
        return '扩建电网工程'
    }
    if (userType === 2) {
        return '新建非线性负荷用户'
    }
    if (userType === 3) {
        return '扩建非线性负荷用户'
    }
    if (userType === 4) {
        return '新建新能源发电站'
    }
    if (userType === 5) {
        return '扩建新能源发电站'
    }
    if (userType === 6) {
        return '敏感及重要用户'
    }
    return '新建电网工程'
}
</script>

<style scoped lang="scss">
:deep(.el-upload-list__item) {
    width: 400px;
}

::v-deep .el-input__wrapper {
    width: 200px !important;
}
</style>
